/* 
 * Ice.java 1.0 2002-10-17
 *
 *  2002 Jouni Smed
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *     * Neither the name of the University of Turku nor the names of its
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
package fi.utu.cs.hockey.rink;

import fi.utu.cs.physics.*;
import fi.utu.cs.appearance.*;
import java.awt.Shape;
import java.awt.Paint;
import java.awt.Color;
import java.awt.Stroke;
import java.awt.geom.Rectangle2D;

/**
 *  Ice. 
 *
 *  @version 1.0, 021017
 *  @author  Jouni Smed
 */
public class Ice extends Boundary implements Shapable
  {
  /** The color of the ice. */
  private Color color = Color.white;

  /** 
   *  A line from <code>d</code> meters from center
   *  with length <code>l</code>, width <code>w</code> and
   *  color <code>c</code>.
   */
  protected Ice()
    {
    super();
    setEthereal();
    }


	protected boolean isCrossedByBoundingBox(double x1, double y1, 
																					 double x2, double y2, double r)
		{
		return false;
		}

	protected boolean isCrossedByLine(double x1, double y1, 
																    double x2, double y2)
		{
		return false;
		}
		
  public void inelasticCollision(Body other)
  	{
  	return;
  	}

  public void elasticCollision(Body other)
  	{
  	return;
  	}
  
  // ***************************************************
  // Methods defined in the Shapable interface  
  // ***************************************************

  public Shape shape()
    {
    return new Rectangle2D.Double(-Rink.WIDTH / 2.0, -Rink.LENGTH / 2.0,
    														 	Rink.WIDTH, Rink.LENGTH);
    }
    
  public boolean isDrawn()
    {
    return false;
    }
      
  public Stroke stroke()
    {
    return null;
    }

  public Color color()
    {
    return color;
    }

  public boolean isFilled()
    {
    return true;
    }

  public Paint paint()
    {
    return color;
    }
  
  }
