/* 
 * DefenseAI.java 1.0 2002-09-03
 *
 *  2002 Jouni Smed
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *     * Neither the name of the University of Turku nor the names of its
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import fi.utu.cs.hockey.ai.*;

public class DefenseAI extends AI implements Constants
	{
	public void react()
		{
		if (!isGameStopped())
			{
			if (isPuckWithinReach())
				{
				switch (getPosition())
					{
					case LEFT_DEFENSE:
						head(headingTo(player(true, LEFT_WING)));
						break;
					case RIGHT_DEFENSE:
						head(headingTo(player(true, RIGHT_WING)));
						break;
					}
				brake(1.0);
				shoot(0.7);
				}
			else
				{
				double[] puck = puck();
				switch (getPosition())
					{
					case LEFT_DEFENSE:
						if (player(false, RIGHT_WING)[Y_COORDINATE] < OUR_ENDZONE_FACEOFF)
							head(headingTo(player(false, RIGHT_WING)));
						else
							{
							if (puck[X_COORDINATE] < 0.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_LEFT, puck[Y_COORDINATE] - 5.0));
							}
						break;
					case RIGHT_DEFENSE:
						if (player(false, LEFT_WING)[Y_COORDINATE] < OUR_ENDZONE_FACEOFF)
							head(headingTo(player(false, LEFT_WING)));
						else
							{
							if (puck[X_COORDINATE] > 0.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_RIGHT, puck[Y_COORDINATE] - 5.0));
							}
						break;
					}
				if (player(true, getPosition())[Y_COORDINATE] < OUR_BLUE_LINE)
					{
					dash(0.5);
					}
				else
					{
					dash(1.0);
					}
				}			
			}
		}		
	}