/* 
 * GoalieAI.java 1.0 2002-09-03
 *
 *  2002 Jouni Smed
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *     * Neither the name of the University of Turku nor the names of its
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import fi.utu.cs.hockey.ai.*;

public class GoalieAI extends AI implements Constants
	{
	public void react()
		{
		if (!isGameStopped())
			{
			double[] puck = puck();
			double[] me = player(true, getPosition());
			
			double range = 1.2; 
			double a = puck[X_COORDINATE];
			double b = puck[Y_COORDINATE] - OUR_GOAL_LINE;
			double c = Math.sqrt(a * a + b * b);
			double x = a * (range / c);
			double y = b * (range / c);
			if (y < OUR_GOAL_LINE)
				{
				y = OUR_GOAL_LINE;
				x = (x > 0.0 ? 1.0 : -1.0) * range;
				}
			head(headingTo(x, y + OUR_GOAL_LINE));
			
			double p = Math.abs(x - me[X_COORDINATE]) + 
								 Math.abs(y - me[Y_COORDINATE]);
			p = (p > 1.0 ? 1.0 : p);
			dash(p);
		
			if (isPuckWithinReach()) 
				{
				PlayerIterator pit = iteratorAll();
				double ourMinY = Double.POSITIVE_INFINITY;
				int ourMinPos = 0;
				double theirMinY = Double.POSITIVE_INFINITY;
				while (pit.hasNext())
					{
					int pos = pit.next();
					if (pos != GOALKEEPER)
						{
						double ourY = player(true, pos)[Y_COORDINATE];
						double theirY = player(false, pos)[Y_COORDINATE];
						if (ourY < ourMinY) 
							{
							ourMinY = ourY;
							ourMinPos = pos;
							}
						if (theirY < theirMinY) 
							{
							theirMinY = theirY;
							}
						}
					}
				if (ourMinY < theirMinY)
					{
					head(headingTo(player(true, ourMinPos)));
					shoot(1.0);
					}
				else
					{
					keepPuck();
					}
				}
			}
		}		
	}